/*
 * Copyright (C), 2000-2005 by the monit project group.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */


#ifndef MONIT_CUSTOMLOG_H
#define MONIT_CUSTOMLOG_H

#include "event.h"
#include "util.h"


/**
 *  This module is used for custom log registration. Users may 
 *  set specific log to be written in the customlog file if
 *  they needs it.
 *
 *  @author Marco Ermini, <marco.ermini@gmail.com>
 *
 *  @file
 */

int   customlog_init() ;
void  customlog_log(const char *) ;
void  customlog_close();


/**
 * Write the customlog file
 * @param E An Event object
 */
void handle_customlog(Event_T E, Service_T service);


/*
 * Reset the customlogformat if changed
 */
void setcustomlogformat(char *);

#endif
