<?php include '../include/header.html'; ?>

<center>
<table width="680"><tr> <td><img src="index.gif"></td></tr></table>
</center>

<?php include '../include/menu.php'; ?>

<h2>Plans for future monit releases</h2>

<h3><u>Introduction:</u></h3>

This document is a draft for future releases of monit. Each feature
item is listed with the responsible for the implementation, the
current progress (the color will go from blue to green) and how we
judge the importance of this feature (high, medium, low).
<p>
Items marked with a <i>low</i> importance will not make it into the
nearest monit release, but maybe in a future release. If you would
like to change anything or add stuff to this list join the <A HREF=
"http://mail.freesoftware.fsf.org/mailman/listinfo/monit-general">monit
mailing lists</A> and let us know.

<br>
<p>

<h3><u>Feature list:</u></h3>

<div style="background: #EFF7FF; padding: 10px;">
<b>Done</b>
<ul style="list-style-type: square;">
  <li>Currently none</li>
</ul>
<b>In progress</b>
<ul style="list-style-type: square;">
  <li>Currently none</li>
</ul>
<b>Planned</b>
<ol>
  <li><a href="#01">Refactor SMTP support</a></li>
  <li><a href="#31">Monitor a (log) file using regex</a></li>
  <li><a href="#32">Customize monit log file output</a></li>
  <li><a href="#03">Allow formating of trailing event description sent in an alert email</a></li>
  <li><a href="#06">URL request for protocol tests (like ldap, ftp, etc.)</a></li>
  <li><a href="#07">Network interfaces health and load monitoring</a></li>
  <li><a href="#08">Device load average tests</a></li>
  <li><a href="#09">Device related caches test</a></li>
  <li><a href="#10">IPv6 support</a></li>
  <li><a href="#11">S.M.A.R.T capable devices monitoring support</a></li>
  <li><a href="#12">Refactor sysdep files in process directory</a></li>
  <li><a href="#18">ARP (MAC address) tests in host services</a></li>
  <li><a href="#19">SCSI ping support for device test</a></li>
  <li><a href="#20">Event ratio dependant action rules</a></li>
  <li><a href="#21">Action list support and optional service name target</a></li>
  <li><a href="#22">Soft failure tolerance for ICMP echo test (ping)</a></li>
  <li><a href="#02">Refactor the CVS repository and release tree</a></li>

</ol>
</div>


<table id="feature">
  <tr>
    <td colspan=2 >
      <h3><a name="01">Refactor SMTP support</a></h3>

      Refactor the SMTP protocol implementation used to send
      alert messages from monit.

      <ol>
        <li>Queue mail that cannot be sent, for later retry. 

        <li>Refactor the SMTP implementation to a small state
        machine and handle smtp-server returned status codes as
        transition points. Thus handling error situations properly.
      </ol>
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>hauk</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>MEDIUM</b></td>
  </tr>
</table>

<table id="feature">
<tr>
<td colspan=2 >
<h3><a name="31">Monitor a file using regex</a></h3>

This function will allow monit to monitor files such as log files for certain 
content. Users can specify a regular expression which will be checked
against the file for each monitor cycle. If a match occurs, monit will 
issue one of the standard actions, such as an alert or a exec. Here is an 
example on how an entry may look like in the monit control file:

<pre>
check file syslog with path /var/log/messages
      if match "^[A-Za-z]+ .[0-9] [0-9][0-9]:[0-9][0-9]:[0-9][0-9].* .* .*$" 
         then alert
</pre>

<p>Monit will maintain the offset of each file (a la logtail) so it would
check only the last  entries. The regex check is done per line or per 512
bytes, whichever comes first.

</td>
</tr>
<tr>
<td width="10%" style="padding-right: 20px;">Responsible:</td>
<td>?</td>
</tr>
<tr>
<td>Progress:</td>
<td bgcolor="blue" align=center>
<b><font color="#ffffff">0%</font></b>
</td>
</tr>
<tr>
<td>Importance:</td>
<td><b>MEDIUM</b></td>
</tr>
</table>


<table id="feature">
<tr>
<td colspan=2 >
<h3><a name="32">Customize monit log file output</a></h3>

Use the same approach as the apache project for configuring log file output. 
The log file format will be set using a global set-statement, <p>

<code>set logformat "%h %l %u %t %>s %b"</code> 

<p>and where applicable the format specifiers match those of apache log file.

</td>
</tr>
<tr>
<td width="10%" style="padding-right: 20px;">Responsible:</td>
<td>?</td>
</tr>
<tr>
<td>Progress:</td>
<td bgcolor="blue" align=center>
<b><font color="#ffffff">0%</font></b>
</td>
</tr>
<tr>
<td>Importance:</td>
<td><b>MEDIUM</b></td>
</tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="03">Allow formating of trailing event description sent in an alert email</a></h3>

      The Event description sent with each alert mail, at the
      bottom of the email, is currently added to every alert
      mail regardless of the MAIL-FORMAT. This should be changed
      so users have complete control on the format of alert
      messages emitted by monit. Suggested formate variable is
      $EVENT_DESCRIPTION.

      <p>
      A spin-off from this request is to refactor the
      internal message passing conducted inside validate.c to
      make code more flexible and to allow protocol routines to
      pass detailed error-messages upwards so they are part of
      the alert message. Having a kind of chained exception
      traceback would be nice. Something like,
      </p>

      <pre>
      Event backtrace: 
      1. 'hostname' failed protocol test [http] at 192.168.1.1
      2. APACHE-STATUS error: 80 percent of Apache processes are logging
      </pre>

      Currently only the first event line (1.) are sent in the
      alert message. The error in line 2 is logged, but it could
      be nice to include it in the alert message to describe
      <i>why</i> the http protocol test failed.
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>?</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>MEDIUM</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="06">URL request for protocol tests (like ldap, ftp, etc.)</a></h3>

      Add document request to relevant protocol tests. Currently
      only the http protocol test support a request option.

    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>?</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="07">Network interfaces health and load monitoring</a></h3>

      Allows to monitor network interfaces (for example "eth0" on linux,
      "hme0" on solaris, etc.) status - functionality and throughput. In the case
      that the interface will fail or the load exceeds some limit, monit
      will do appropriate action.
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>?</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="08">Device load average tests</a></h3>

      Watch filesystem load:
      <p>
      - read/write blocks per second ratio<br>
      - transactions per second ratio<br>
      - queue lengths<br>
      - response times<br>
      </p>
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>Martin</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="09">Device related caches test</a></h3>

      Watch cache hit ratio for inode, directory entry, buffer
      and similar caches.
   </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>Martin</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="10">IPv6 support</a></h3>

      Make monit speak Ipv6, both for network protocol
      test and in the built-in web server.
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>?</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="11">S.M.A.R.T capable devices monitoring support</a></h3>

      Support for monitoring health of devices which supports S.M.A.R.T
      technology. It allows you to watch for example disks and tape health,
      temperature, block realloacation, number of start count, power on hours,
      spin up time, etc. and allows you to detect bad device before
      catastrophic failure will occure.
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>?</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="12">Refactor sysdep files in process directory</a></h3>

      There is a lot of common code in the process directory that can be
      consolidated, and there are also a lot of differing methods used to
      pull out kernel data. This can also be somewhat consolidated and
      simplified.
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>Rory</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td><td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="18">ARP (MAC address) tests in host services</a></h3>
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>Christian</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="19">SCSI ping support for device test</a></h3>

      Allows to test whether the device is accessible. It is common
      test used by clusters for shared device (disk) based quorums
      (based on SCSI reservation).
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>Martin</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="20">Event ratio dependant action rules</a></h3>

      Allows to set stack of rules which will evaluate given
      action based on specific event occurence (error level).<br>

      <p>
      Possible syntax (example):
      </p>

      <pre>
      if X EVENT within Y cycles then ACTION
      </pre>

      <p>
      where:<br>
      X      = number of event occurences<br>
      EVENT  = event type<br>
      Y      = number of consequent cycles<br>
      ACTION = given action (alert|restart|unmonitor|exec|...)<br>
      </p>
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">
      Responsible:</td>
    <td>?</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>MEDIUM</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="21">Action list support and optional service name target</a></h3>

      Allows to specify list of actions, optionaly referencing other
      service name in monit control file.<br>

      <p>
      Possible syntax (example):
      </p>

      <pre>
      IF FAILED test THEN {action [service], ...}
      </pre>

      <p>
      Example usage:
      </p>

      <pre>
      check process ipsec with pidfile /var/run/ipsec.pid
        start program = "/etc/init.d/ipsec start"
        stop program = "/etc/init.d/ipsec stop"

      check host theotherside with address the.other.side
        if failed icmp type echo then alert, restart ipsec
      </pre>
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>?</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
  <tr>
    <td colspan=2>
      <h3><a name="22">Soft failure tolerance for ICMP echo test (ping)</a></h3>

      Allows to send more ICMP echo packets in the ping test during one
      cycle and tolerate partial loss of some packets up to the optional
      limit.
    </td>
  </tr>
  <tr>
    <td width="10%" style="padding-right: 20px;">Responsible:</td>
    <td>?</td>
  </tr>
  <tr>
    <td>Progress:</td>
    <td bgcolor="blue" align=center>
      <b><font color="#ffffff">0%</font></b>
    </td>
  </tr>
  <tr>
    <td>Importance:</td>
    <td><b>LOW</b></td>
  </tr>
</table>


<table id="feature">
<tr>
<td colspan=2>
<h3><a name="02">Refactor the CVS repository and release tree</a></h3> 

The goal is to move all source code into a src/
directory. After refactoring the monit top-level directory
should look like this:

<pre>
CHANGES.txt   contrib/      doc/        Makefile.in  src/
configure*    CONTRIBUTORS  install-sh  man/         STATUS
configure.ac  COPYING       LICENSE     README
</pre>
</td>
</tr>
<tr>
<td width="10%" style="padding-right: 20px;">Responsible:</td>
<td>hauk</td>
</tr>
<tr>
<td>Progress:</td>
<td bgcolor="blue" align=center>
<b><font color="#ffffff">0%</font></b>
</td>
</tr>
<tr>
<td>Importance:</td>
<td><b>LOW</b></td>
</tr>
</table>


<?php include '../include/footer.html'; ?>
